<?php
// c-stream API
define("CS_API_URL", "https://www.c-streaming.net/v5/c-stream-api/");
define("CS_KAISHA_ID", "xxxxx");//登録の会社IDを入れる
define("CS_ACCESS_KEY", "xxxxxxxxxxx");//API用のaccess_key

// c_stream_apiクラス生成
class c_stream_api {

	//プロパティを定義
	private $kaisha_id;
	private $access_key;
	private $host_name;
	private $api_url_get;

	// コンストラクタ
	function __construct($arrBaseParams){

		// APIに必要なパラメータ
		$check_base_params = array();
		$check_base_params[] = "kaisha_id";
		$check_base_params[] = "access_key";

		// エラーチェック
		$err_message = 'パラメータがありません。';
		$this->check_param($check_base_params, $arrBaseParams, $err_message);

		// 基本情報
		$this->kaisha_id = $arrBaseParams['kaisha_id'];
		$this->sub_kaisha_id = $arrBaseParams['kaisha_id'];
		if ($arrBaseParams['sub_kaisha_id'] && $arrBaseParams['sub_kaisha_id'] != "") {
			$this->sub_kaisha_id = $arrBaseParams['sub_kaisha_id'];
		}
		$this->access_key = $arrBaseParams['access_key'];
		$this->host_name = $_SERVER['SERVER_NAME'];
		$this->api_url_get = "?kaisha_id=".$this->kaisha_id."&sub_kaisha_id=".$this->sub_kaisha_id."&access_key=".$this->access_key."&host_name=".$this->host_name;

	}

	// ログインチェックAPI
	function call_el_userlogin_check_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);
	}

	// 講座一覧取得API
	function call_el_course_list_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}

	// 講座グループ一覧取得API
	function call_el_courseGroup_list_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}

	// 講座分類一覧取得API
	function call_el_course_category_list_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}

	// 受講状況取得API
	function call_el_user_record_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}

	// アクションログ情報取得API
	function call_el_actionlog_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}

	// 講座グループ個別取得API
	function call_el_courseGroup_kobetsu_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}

	// 講座個別取得API
	function call_el_course_kobetsu_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);
		//return json_encode($result);

	}

	// 講義情報取得API
	function call_el_course_lecture_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}

	// 動画視聴履歴取得API
	function call_vd_movie_log_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."vd/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);
	}

	// 受講者情報取得API
	function call_el_userInfo_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);
		//return json_encode($result);

	}

	// 受講者情報編集API
	function call_el_userInfo_upd_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);
		//return $result;

	}

	// 受講権限編集API
	function call_el_userAuth_upd_api($arrParams) {


		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);
		//return json_encode($result);


	}


	// 商品情報取得API
	function call_el_productInfo_get_api($arrParams) {


		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);
		//print_r($result);

		return json_decode($result['content'],true);


	}

	// 商品一覧取得API
	function call_el_productList_get_api($arrParams) {


		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);
		//print_r($result);

		return json_decode($result['content'],true);


	}


	// 販売情報登録API
	function call_el_orderInfo_upd_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);
		//print_r($result);

		return json_decode($result['content'],true);

	}


	// 販売履歴登録API
	function call_el_orderRireki_upd_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);
		//print_r($result);

		return json_decode($result['content'],true);
		//return $result;

	}

	// 販売履歴取得API
	function call_el_orderRireki_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);
		//print_r($result);

		return json_decode($result['content'],true);

	}


	// 販売セクション請求書情報取得API
	function call_el_SectionBillInfo_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);
		//print_r($result);

		return json_decode($result['content'],true);

	}


	// メール文面取得API
	function call_el_MailContents_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);
		//print_r($result);

		return json_decode($result['content'],true);

	}


		// 採番API
	function call_el_numbering_api($arrParams) {
		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		/*
		 // Call API URL 追加
		 if (is_array($arrParams)) {
		 $call_url .= "&".http_build_query($arrParams);
		 }

		 // API Call
		 $xml = simplexml_load_file($call_url);
		 */
		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}


	// 退会API
	function call_el_quit_api($arrParams) {
		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		// Call API URL 追加
		if (is_array($arrParams)) {
			$call_url .= "&".http_build_query($arrParams);
		}

		 /*
		 // API Call
		 $xml = simplexml_load_file($call_url);
		 */
		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);
	}


	// GMOクレジットオーダー情報編集API
	function call_el_GMOCreditOrderApiInfo_upd_api($arrParams) {


		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);


	}

	// 継続決済IF情報取得API(スペルミス)
	function call_el_montlypayIFInfo_get_api($arrParams) {
		return $this->call_el_monthlypayIFInfo_get_api($arrParams);
	}

	// 継続決済IF情報取得API
	function call_el_monthlypayIFInfo_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}
	// 継続決済IF情報編集API
	function call_el_monthlypayIFInfo_upd_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);
		//return json_encode($result);

	}

	// 領収書情報取得API
	function call_el_ReceiptInfo_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);
	}


	// 講座ランキング取得API
	function call_el_course_ranking_list_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'],true);

	}

	// 受講者一覧取得API
	function call_el_userList_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		// Call API URL 追加
		if (is_array($arrParams)) {
			foreach ($arrParams as $key => $value) {
				$call_url .= "&".$key."=".$value;
			}
		}

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'], true);

	}

	// お知らせ情報取得API
	function call_el_info_get_api($arrParams) {

		// Call API URL 基本
		$api_filename = ltrim(__FUNCTION__, 'call_');
		$call_url = CS_API_URL."el/".$api_filename.".php".$this->api_url_get;

		// Call API URL 追加
		if (is_array($arrParams)) {
			foreach ($arrParams as $key => $value) {
				$call_url .= "&".$key."=".$value;
			}
		}

		$result = $this->http_post($call_url, $arrParams);

		return json_decode($result['content'], true);

	}
	/**********************/
	/****** 各種関数 ******/
	/**********************/

	// パラメータチェック関数
	function check_param($arrCheckParams, $arrDate, $errMes) {

		if (!is_array($arrCheckParams)) {
			throw new Exception($errMes);
		} elseif (!is_array($arrDate)) {
			throw new Exception($errMes);
		} else {
			foreach ($arrCheckParams as $value) {
				if (!$arrDate[$value] || $arrDate[$value] == "") {
					throw new Exception($errMes);
				}
			}
		}

	}

	// オブジェクトを配列に変換
	function forArray($object) {

		$return = array();

		if (is_array($object)) {
			foreach ($object as $key => $value) {
				$return[$key] = self::forArray($value);
			}
		} else {
			$vars = get_object_vars($object);
			if (is_array($vars)) {
				foreach($vars as $key => $value) {
					if ($key && !$value) {
						if ($value === "0") {
							$return[$key] = 0;
						} else {
							$return[$key] = null;
						}
					} else {
						$return[$key] = self::forArray($value);
					}
					/*
					$return[$key] = ($key && !$value) ? null : self::forArray($value);
					*/
					/*
					if ($key && ($value === "" || is_null($value))) {
						$return[$key] = null;
					} else {
						$return[$key] = self::forArray($value);
					}
					*/
				}
			} else {
				return $object;
			}
		}

		return $return;

	}

	// オブジェクトを配列に変換
	function forArray2($object) {

		$return = json_decode(json_encode($object), true);

		return $return;

	}
	function http_post ($url, $data)
	{
	  $data_url = http_build_query ($data);
	  $data_len = strlen ($data_url);

	  $ch = curl_init($url);

	  $postOption = [
	  		CURLOPT_POST           => true,
	  		//CURLOPT_HEADER         => true,
	  		CURLOPT_TIMEOUT        => 10,
	  		CURLOPT_POSTFIELDS     => http_build_query($data),
	  		CURLOPT_RETURNTRANSFER => true,
	  ];

	  curl_setopt_array($ch, $postOption );

	  $ret = array();
	  $ret['content'] = curl_exec($ch);
	  $ret['error'] = curl_errno($ch);
	  $ret['errmsg']= curl_error($ch);
	  $ret['header']= curl_getinfo($ch);

	  return $ret;

	}
}
?>
